package com.zhongzheng.modules.course.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.common.utils.ServletUtils;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import com.zhongzheng.modules.course.bo.MajorExamineAddBo;
import com.zhongzheng.modules.course.bo.MajorExamineQueryBo;
import com.zhongzheng.modules.course.bo.MajorExamineEditBo;
import com.zhongzheng.modules.course.domain.MajorExamine;
import com.zhongzheng.modules.course.mapper.MajorExamineMapper;
import com.zhongzheng.modules.course.vo.MajorExamineVo;
import com.zhongzheng.modules.course.service.IMajorExamineService;
import org.springframework.util.CollectionUtils;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 考期Service业务层处理
 *
 * @author ruoyi
 * @date 2021-10-09
 */
@Service
public class MajorExamineServiceImpl extends ServiceImpl<MajorExamineMapper, MajorExamine> implements IMajorExamineService {

    @Override
    public MajorExamineVo queryById(Long id){
        MajorExamineQueryBo majorExamineQueryBo = new MajorExamineQueryBo();
        majorExamineQueryBo.setId(id);
        List<MajorExamineVo> majorExamineVos = entity2Vo(baseMapper.queryList(majorExamineQueryBo));
        if (CollectionUtils.isEmpty(majorExamineVos)){
            throw new IllegalArgumentException("请输入正确的ID");
        }
        return BeanUtil.toBean(majorExamineVos.get(0), MajorExamineVo.class);
    }

    @Override
    public List<MajorExamineVo> queryList(MajorExamineQueryBo bo) {
        return entity2Vo(baseMapper.queryList(bo));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<MajorExamineVo> entity2Vo(Collection<MajorExamineVo> collection) {
        List<MajorExamineVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, MajorExamineVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<MajorExamineVo> page = (Page<MajorExamineVo>)collection;
            Page<MajorExamineVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(MajorExamineAddBo bo) {
        MajorExamine add = BeanUtil.toBean(bo, MajorExamine.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setEncoder(ServletUtils.getEncoded("KQ"));
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(MajorExamineEditBo bo) {
        MajorExamine update = BeanUtil.toBean(bo, MajorExamine.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(MajorExamine entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
